//+------------------------------------------------------------------+
//|                            MML-v2 Based on Murrey_Math_Lines.mq4 |
//|                         Copyright  2004, Vladislav Goshkov (VG).|
//|                                                      4vg@mail.ru |
//|                      code change by Ben L.  sbgtrading@yahoo.com |
//|                 code added by Xard777  xard777@connectfree.co.uk |
//+------------------------------------------------------------------+
#property copyright "Vladislav Goshkov (VG) && Ben L."
#property link      "4vg@mail.ru && sbgtrading@yahoo.com"

#property indicator_chart_window

// ============================================================================================
// * Line 8/8 & 0/8 (Ultimate Support and Ultimate Resistance).
// * Those lines are the most strong concerning Support and esistance.
// ============================================================================================
//* Line 7/8  (Weak, Place to Stop and Reverse).
//* This line is weak. If suddenly the price was going too fast and too far and stops around this line 
//* it means the price will reverse down very soon. If the price did not stop near this line this price 
//* will continue the movement to the line 8/8.
// ============================================================================================
//* Line 1/8  (Weak, Place to Stop and Reverse).
//* This line is weak. If suddenly the price was going too fast and too far and stops around this line 
//* it means the price will reverse up very soon. If the price did not stop near this line this price
//* will continue the movement down to the line 0/8.
// ============================================================================================
//* Line 2/8 and 6/8 (Pivot, Reverse)
//* Those two lines yield the line 4/8 only to the strength to reverse the price movement.
// ============================================================================================
//* Line 5/8 (Top of Trading Range)
//* The price is spending the about 40% of the time on the movement between the lines 5/8 and 3/8. 
//* If the price is moving near line 5/8 and stopping near the line during the 10 - 12 days so it means 
//* that it is necessary to sell in this "bonus zone" (some people are doing like this) but if the price is keeping the tendency to stay above 
//* 5/8 line, so it means that the price will be above. But if the price is droping below 5/8 line it means that the price will continue 
//* falling to the next level of resistance.
// ============================================================================================
//* Line 3/8 (Bottom of Trading Range).
//* If the price is below this line and in uptrend it means that it will be very difficult for the price to break this level. 
//* If the price broke this line during the uptrend and staying above during the 10 12 days it means that the price will be above this line 
//* during the 40% of its time moving between this line and 5/8 line.
// ============================================================================================
//* Line 4/8 (Major Support/Resistance Line).
//* It is the major line concerning support and resistance. This leve is the better for the new sell or buy. 
//* It is the strong level of support of the price is above 4/8. It is the fine resistance line if the price is below this 4/8 line. 
// ============================================================================================
extern int P = 64;
extern int StepBack = 0;

extern bool BabyLines=false;

extern color  mml_clr_m_2_8 = Red;       // [-2]/8
extern color  mml_clr_m_1_8 = OrangeRed;       // [-1]/8
extern color  mml_clr_0_8   = DodgerBlue;        //  [0]/8
extern color  mml_clr_1_8   = Yellow;      //  [1]/8
extern color  mml_clr_2_8   = HotPink;         //  [2]/8
extern color  mml_clr_3_8   = Lime;       //  [3]/8
extern color  mml_clr_4_8   = DodgerBlue;        //  [4]/8
extern color  mml_clr_5_8   = Lime;       //  [5]/8
extern color  mml_clr_6_8   = HotPink;         //  [6]/8
extern color  mml_clr_7_8   = Yellow;      //  [7]/8
extern color  mml_clr_8_8   = DodgerBlue;        //  [8]/8
extern color  mml_clr_p_1_8 = OrangeRed;       // [+1]/8
extern color  mml_clr_p_2_8 = Red;       // [+2]/8

extern int    mml_wdth_m_2_8 = 2;        // [-2]/8
extern int    mml_wdth_m_1_8 = 2;        // [-1]/8
extern int    mml_wdth_0_8   = 2;        //  [0]/8
extern int    mml_wdth_1_8   = 2;        //  [1]/8
extern int    mml_wdth_2_8   = 2;        //  [2]/8
extern int    mml_wdth_3_8   = 2;        //  [3]/8
extern int    mml_wdth_4_8   = 0;        //  [4]/8
extern int    mml_wdth_5_8   = 2;        //  [5]/8
extern int    mml_wdth_6_8   = 2;        //  [6]/8
extern int    mml_wdth_7_8   = 2;        //  [7]/8
extern int    mml_wdth_8_8   = 2;        //  [8]/8
extern int    mml_wdth_p_1_8 = 2;        // [+1]/8
extern int    mml_wdth_p_2_8 = 2;        // [+2]/8

extern int    mml_styl_m_2_8 = 0;        // [-2]/8
extern int    mml_styl_m_1_8 = 0;        // [-1]/8
extern int    mml_styl_0_8   = 0;        //  [0]/8
extern int    mml_styl_1_8   = 0;        //  [1]/8
extern int    mml_styl_2_8   = 0;        //  [2]/8
extern int    mml_styl_3_8   = 0;        //  [3]/8
extern int    mml_styl_4_8   = 1;        //  [4]/8
extern int    mml_styl_5_8   = 0;        //  [5]/8
extern int    mml_styl_6_8   = 0;        //  [6]/8
extern int    mml_styl_7_8   = 0;        //  [7]/8
extern int    mml_styl_8_8   = 0;        //  [8]/8
extern int    mml_styl_p_1_8 = 0;        // [+1]/8
extern int    mml_styl_p_2_8 = 0;        // [+2]/8

extern color  MarkColor   = Blue;
extern int    MarkNumber  = 217;


double  dmml = 0,
        dvtl = 0,
        sum  = 0,
        PeriodLow = 0,
        PeriodHigh = 0,
        mn = 0,
        mx = 0,
        x1 = 0,
        x2 = 0,
        x3 = 0,
        x4 = 0,
        x5 = 0,
        x6 = 0,
        y1 = 0,
        y2 = 0,
        y3 = 0,
        y4 = 0,
        y5 = 0,
        y6 = 0,
        octave = 0,
        fractal = 0,
        range   = 0,
        finalH  = 0,
        finalL  = 0,
        mml[13];

string  ln_txt[13],        
        buff_str = "";
        
int     
        bnLow   = 0,
        bnHigh   = 0,
        OctLinesCnt = 13,
        mml_clr[13],
        mml_wdth[13],
        mml_styl[13],
        mml_shft = 40,
        nTime = 0,
        CurPeriod = 0,
        i = 0;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init() {
//---- indicators
   
   ln_txt[0]  = "[-2/8]BUY!";//  extremely overshoot [-2/8]";// [-2/8]
   ln_txt[1]  = "[-1/8]buy";//  overshoot [-1/8]";// [-1/8]
   ln_txt[2]  = "[0/8]Good sup";//  Ultimate Support - extremely oversold [0/8]";// [0/8]
   ln_txt[3]  = "[1/8]Weak sup";//  Weak, Place to Stop and Reverse - [1/8]";// [1/8]
   ln_txt[4]  = "[2/8]Pivot buy";//  Pivot, Reverse - major [2/8]";// [2/8]
   ln_txt[5]  = "[3/8]Range Bottom";//  Bottom of Trading Range - [3/8], if 10-12 bars then 40% Time. BUY Premium Zone";//[3/8]
   ln_txt[6]  = "[4/8]Center  ";//Major Support/Resistance Pivotal Point [4/8]- Best New BUY or SELL level";// [4/8]
   ln_txt[7]  = "[5/8]Range Top";// Top of Trading Range - [5/8], if 10-12 bars then 40% Time. SELL Premium Zone";//[5/8]
   ln_txt[8]  = "[6/8]Pivot sell";//  Pivot, Reverse - major [6/8]";// [6/8]
   ln_txt[9]  = "[7/8]Weak res";//   Weak, Place to Stop and Reverse - [7/8]";// [7/8]
   ln_txt[10] = "[8/8]Good res";//  Ultimate Resistance - extremely overbought [8/8]";// [8/8]
   ln_txt[11] = "[+1/8]sell";//  overshoot [+1/8]";// [+1/8]
   ln_txt[12] = "[+2/8]SELL!";//  extremely overshoot [+2/8]";// [+2/8]


   mml_clr[0]  = mml_clr_m_2_8;   mml_wdth[0] = mml_wdth_m_2_8;   mml_styl[0] = mml_styl_m_2_8;// [-2]/8
   mml_clr[1]  = mml_clr_m_1_8;   mml_wdth[1] = mml_wdth_m_1_8;   mml_styl[1] = mml_styl_m_1_8;// [-1]/8
   mml_clr[2]  = mml_clr_0_8;     mml_wdth[2] = mml_wdth_0_8;     mml_styl[2] = mml_styl_0_8;//  [0]/8
   mml_clr[3]  = mml_clr_1_8;     mml_wdth[3] = mml_wdth_1_8;     mml_styl[3] = mml_styl_1_8;//  [1]/8
   mml_clr[4]  = mml_clr_2_8;     mml_wdth[4] = mml_wdth_2_8;     mml_styl[4] = mml_styl_2_8;//  [2]/8
   mml_clr[5]  = mml_clr_3_8;     mml_wdth[5] = mml_wdth_3_8;     mml_styl[5] = mml_styl_3_8;//  [3]/8
   mml_clr[6]  = mml_clr_4_8;     mml_wdth[6] = mml_wdth_4_8;     mml_styl[6] = mml_styl_4_8;//  [4]/8
   mml_clr[7]  = mml_clr_5_8;     mml_wdth[7] = mml_wdth_5_8;     mml_styl[7] = mml_styl_5_8;//  [5]/8
   mml_clr[8]  = mml_clr_6_8;     mml_wdth[8] = mml_wdth_6_8;     mml_styl[8] = mml_styl_6_8;//  [6]/8
   mml_clr[9]  = mml_clr_7_8;     mml_wdth[9] = mml_wdth_7_8;     mml_styl[9] = mml_styl_7_8;//  [7]/8
   mml_clr[10] = mml_clr_8_8;     mml_wdth[10]= mml_wdth_8_8;     mml_styl[10]= mml_styl_8_8;//  [8]/8
   mml_clr[11] = mml_clr_p_1_8;   mml_wdth[11]= mml_wdth_p_1_8;   mml_styl[11]= mml_styl_p_1_8;// [+1]/8
   mml_clr[12] = mml_clr_p_2_8;   mml_wdth[12]= mml_wdth_p_2_8;   mml_styl[12]= mml_styl_p_2_8;// [+2]/8
   
   for( i=0; i<OctLinesCnt; i++) {
         mml[i] = 0;
      }
   
//----
   return(0);
  }

//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit() {
//---- 
Comment(" ");
for(i=0;i<OctLinesCnt;i++) {
    buff_str = "mml"+i;
    ObjectDelete(buff_str);
    buff_str = "mml_txt"+i;
    ObjectDelete(buff_str);
    }
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start() {

//---- 

if((nTime != Time[0]) || (CurPeriod != Period())) {
   
  //price
   bnLow = Lowest(NULL,PERIOD_D1,MODE_LOW,P,StepBack);
   bnHigh = Highest(NULL,PERIOD_D1,MODE_HIGH,P,StepBack);

   PeriodLow = iLow(NULL,PERIOD_D1,bnLow);
   PeriodHigh = iHigh(NULL,PERIOD_D1,bnHigh);
   Comment("Murrey Math ",DoubleToStr(P,0), " day frame");

//determine fractal.....
   if( PeriodHigh<=250000 && PeriodHigh>25000 )
   fractal=100000;
   else
     if( PeriodHigh<=25000 && PeriodHigh>2500 )
     fractal=10000;
     else
       if( PeriodHigh<=2500 && PeriodHigh>250 )
       fractal=1000;
       else
         if( PeriodHigh<=250 && PeriodHigh>25 )
         fractal=100;
         else
           if( PeriodHigh<=25 && PeriodHigh>12.5 )
           fractal=12.5;
           else
             if( PeriodHigh<=12.5 && PeriodHigh>6.25)
             fractal=12.5;
             else
               if( PeriodHigh<=6.25 && PeriodHigh>3.125 )
               fractal=6.25;
               else
                 if( PeriodHigh<=3.125 && PeriodHigh>1.5625 )
                 fractal=3.125;
                 else
                   if( PeriodHigh<=1.5625 && PeriodHigh>0.390625 )
                   fractal=1.5625;
                   else
                     if( PeriodHigh<=0.390625 && PeriodHigh>0)
                     fractal=0.1953125;
   
   range=(PeriodHigh-PeriodLow);
   sum=MathFloor(MathLog(fractal/range)/MathLog(2));
   octave=fractal*(MathPow(0.5,sum));
   mn=MathFloor(PeriodLow/octave)*octave;
   if( (mn+octave)>PeriodHigh )
      mx=mn+octave; 
   else
      mx=mn+(2*octave);

// calculating xx
//x2
    if( (PeriodLow>=(3*(mx-mn)/16+mn)) && (PeriodHigh<=(9*(mx-mn)/16+mn)) )
         x2=mn+(mx-mn)/2; 
    else x2=0;
//x1
    if( (PeriodLow>=(mn-(mx-mn)/8))&& (PeriodHigh<=(5*(mx-mn)/8+mn)) && (x2==0) )
         x1=mn+(mx-mn)/2; 
    else x1=0;

//x4
    if( (PeriodLow>=(mn+7*(mx-mn)/16))&& (PeriodHigh<=(13*(mx-mn)/16+mn)) )
         x4=mn+3*(mx-mn)/4; 
    else x4=0;

//x5
    if( (PeriodLow>=(mn+3*(mx-mn)/8))&& (PeriodHigh<=(9*(mx-mn)/8+mn))&& (x4==0) )
         x5=mx; 
    else x5=0;

//x3
    if( (PeriodLow>=(mn+(mx-mn)/8))&& (PeriodHigh<=(7*(mx-mn)/8+mn))&& (x1==0) && (x2==0) && (x4==0) && (x5==0) )
         x3=mn+3*(mx-mn)/4; 
    else x3=0;

//x6
    if( (x1+x2+x3+x4+x5) ==0 )
         x6=mx; 
    else x6=0;

     finalH = x1+x2+x3+x4+x5+x6;

// calculating yy
//y1
    if( x1>0 )
         y1=mn; 
    else y1=0;

//y2
    if( x2>0 )
         y2=mn+(mx-mn)/4; 
    else y2=0;

//y3
    if( x3>0 )
         y3=mn+(mx-mn)/4; 
    else y3=0;

//y4
    if( x4>0 )
         y4=mn+(mx-mn)/2; 
    else y4=0;

//y5
    if( x5>0 )
         y5=mn+(mx-mn)/2; 
    else y5=0;

//y6
    if( (finalH>0) && ((y1+y2+y3+y4+y5)==0) )
         y6=mn; 
    else y6=0;

    finalL = y1+y2+y3+y4+y5+y6;

   dmml = (finalH-finalL)/8;


   mml[0]=(finalL-dmml*2); //-2/8
   for( i=1; i<OctLinesCnt; i++) {
        mml[i] = mml[i-1] + dmml;
        }
   for( i=0; i<OctLinesCnt; i++ ){
        buff_str = "mml"+i;
        if(ObjectFind(buff_str) == -1) {
           ObjectCreate(buff_str, OBJ_HLINE , 0,Time[0], mml[i]);
           ObjectSet(buff_str, OBJPROP_STYLE, mml_styl[i]);
           ObjectSet(buff_str, OBJPROP_COLOR, mml_clr[i]);
           ObjectSet(buff_str, OBJPROP_WIDTH, mml_wdth[i]);
       ObjectMove(buff_str, 0, Time[0],  mml[i]);
           }
        else {
      ObjectMove(buff_str, 0, Time[0],  mml[i]);
           }
             
        buff_str = "mml_txt"+i;
        if(ObjectFind(buff_str) == -1) {
           ObjectCreate(buff_str, OBJ_TEXT, 0, Time[mml_shft], mml_shft);
           ObjectSetText(buff_str, ln_txt[i], 8, "Arial", mml_clr[i]);
           ObjectMove(buff_str, 0, Time[mml_shft],  mml[i]);
           }
        else {
           ObjectMove(buff_str, 0, Time[mml_shft],  mml[i]);
           }
        } // for( i=1; i<=OctLinesCnt; i++ ){

   nTime    = Time[0];
   CurPeriod= Period();
   
   //Baby Lines
double bm222,bm224,bm226;
double bm112,bm114,bm116;
double bm02,bm04,bm06;
double bm12,bm14,bm16;
double bm22,bm24,bm26;
double bm32,bm34,bm36;
double bm42,bm44,bm46;
double bm52,bm54,bm56;
double bm62,bm64,bm66;
double bm72,bm74,bm76;
double bm82,bm84,bm86;
double bm92,bm94,bm96;

bm222 = ((mml[1]-mml[0])/4)+mml[0];
bm224 = ((mml[1]-mml[0])/2)+mml[0];
bm226 = ((mml[1]-mml[0])/4)*3+mml[0];

bm112 = ((mml[2]-mml[1])/4)+mml[1];
bm114 = ((mml[2]-mml[1])/2)+mml[1];
bm116 = ((mml[2]-mml[1])/4)*3+mml[1];

bm02 = ((mml[3]-mml[2])/4)+mml[2];
bm04 = ((mml[3]-mml[2])/2)+mml[2];
bm06 = ((mml[3]-mml[2])/4)*3+mml[2];

bm12 = ((mml[4]-mml[3])/4)+mml[3];
bm14 = ((mml[4]-mml[3])/2)+mml[3];
bm16 = ((mml[4]-mml[3])/4)*3+mml[3];

bm22 = ((mml[5]-mml[4])/4)+mml[4];
bm24 = ((mml[5]-mml[4])/2)+mml[4];
bm26 = ((mml[5]-mml[4])/4)*3+mml[4];

bm32 = ((mml[6]-mml[5])/4)+mml[5];
bm34 = ((mml[6]-mml[5])/2)+mml[5];
bm36 = ((mml[6]-mml[5])/4)*3+mml[5];

bm42 = ((mml[7]-mml[6])/4)+mml[6];
bm44 = ((mml[7]-mml[6])/2)+mml[6];
bm46 = ((mml[7]-mml[6])/4)*3+mml[6];

bm52 = ((mml[8]-mml[7])/4)+mml[7];
bm54 = ((mml[8]-mml[7])/2)+mml[7];
bm56 = ((mml[8]-mml[7])/4)*3+mml[7];

bm62 = ((mml[9]-mml[8])/4)+mml[8];
bm64 = ((mml[9]-mml[8])/2)+mml[8];
bm66 = ((mml[9]-mml[8])/4)*3+mml[8];

bm72 = ((mml[10]-mml[9])/4)+mml[9];
bm74 = ((mml[10]-mml[9])/2)+mml[9];
bm76 = ((mml[10]-mml[9])/4)*3+mml[9];

bm82 = ((mml[11]-mml[10])/4)+mml[10];
bm84 = ((mml[11]-mml[10])/2)+mml[10];
bm86 = ((mml[11]-mml[10])/4)*3+mml[10];

bm92 = ((mml[12]-mml[11])/4)+mml[11];
bm94 = ((mml[12]-mml[11])/2)+mml[11];
bm96 = ((mml[12]-mml[11])/4)*3+mml[11];
 
 //Baby 2 Column
if (BabyLines) {

ObjectDelete("bm222_Line");
ObjectCreate("bm222_Line", OBJ_HLINE,0, Time[0],bm222);
ObjectSet("bm222_Line",OBJPROP_COLOR,DarkSlateGray);
ObjectSet("bm222_Line",OBJPROP_STYLE,STYLE_SOLID);
ObjectSet("bm222_Line",OBJPROP_RAY, false);
ObjectSet("bm222_Line",OBJPROP_WIDTH,0);  
 
ObjectDelete("bm224_Line");
ObjectCreate("bm224_Line", OBJ_HLINE,0, Time[0],bm224);
ObjectSet("bm224_Line",OBJPROP_COLOR,DarkSlateGray);
ObjectSet("bm224_Line",OBJPROP_STYLE,STYLE_DASH);
ObjectSet("bm224_Line",OBJPROP_RAY,false);
ObjectSet("bm224_Line",OBJPROP_WIDTH,0);

ObjectDelete("bm226_Line");
ObjectCreate("bm226_Line", OBJ_HLINE,0, Time[0],bm226);
ObjectSet("bm226_Line",OBJPROP_COLOR,DarkSlateGray);
ObjectSet("bm226_Line",OBJPROP_STYLE,STYLE_SOLID);
ObjectSet("bm226_Line",OBJPROP_RAY,false);
ObjectSet("bm226_Line",OBJPROP_WIDTH,0); 

ObjectDelete("bm112_Line");
ObjectCreate("bm112_Line", OBJ_HLINE,0, Time[0],bm112);
ObjectSet("bm112_Line",OBJPROP_COLOR,DarkSlateGray);
ObjectSet("bm112_Line",OBJPROP_STYLE,STYLE_SOLID);
ObjectSet("bm112_Line",OBJPROP_RAY,false);
ObjectSet("bm112_Line",OBJPROP_WIDTH,0);  
 
ObjectDelete("bm114_Line");
ObjectCreate("bm114_Line", OBJ_HLINE,0, Time[0],bm114);
ObjectSet("bm114_Line",OBJPROP_COLOR,DarkSlateGray);
ObjectSet("bm114_Line",OBJPROP_STYLE,STYLE_DASH);
ObjectSet("bm114_Line",OBJPROP_RAY,false);
ObjectSet("bm114_Line",OBJPROP_WIDTH,0);

ObjectDelete("bm116_Line");
ObjectCreate("bm116_Line", OBJ_HLINE,0, Time[0],bm116);
ObjectSet("bm116_Line",OBJPROP_COLOR,DarkSlateGray);
ObjectSet("bm116_Line",OBJPROP_STYLE,STYLE_SOLID);
ObjectSet("bm116_Line",OBJPROP_RAY,false);
ObjectSet("bm116_Line",OBJPROP_WIDTH,0); 

ObjectDelete("bm02_Line");
ObjectCreate("bm02_Line", OBJ_HLINE,0, Time[0],bm02);
ObjectSet("bm02_Line",OBJPROP_COLOR,DarkSlateGray);
ObjectSet("bm02_Line",OBJPROP_STYLE,STYLE_SOLID);
ObjectSet("bm02_Line",OBJPROP_RAY,false);
ObjectSet("bm02_Line",OBJPROP_WIDTH,0);  
 
ObjectDelete("bm04_Line");
ObjectCreate("bm04_Line", OBJ_HLINE,0, Time[0],bm04);
ObjectSet("bm04_Line",OBJPROP_COLOR,DarkSlateGray);
ObjectSet("bm04_Line",OBJPROP_STYLE,STYLE_DASH);
ObjectSet("bm04_Line",OBJPROP_RAY,false);
ObjectSet("bm04_Line",OBJPROP_WIDTH,0);

ObjectDelete("bm06_Line");
ObjectCreate("bm06_Line", OBJ_HLINE,0, Time[0],bm06);
ObjectSet("bm06_Line",OBJPROP_COLOR,DarkSlateGray);
ObjectSet("bm06_Line",OBJPROP_STYLE,STYLE_SOLID);
ObjectSet("bm06_Line",OBJPROP_RAY,false);
ObjectSet("bm06_Line",OBJPROP_WIDTH,0); 

ObjectDelete("bm12_Line");
ObjectCreate("bm12_Line", OBJ_HLINE,0, Time[0],bm12);
ObjectSet("bm12_Line",OBJPROP_COLOR,DarkSlateGray);
ObjectSet("bm12_Line",OBJPROP_STYLE,STYLE_SOLID);
ObjectSet("bm12_Line",OBJPROP_RAY,false);
ObjectSet("bm12_Line",OBJPROP_WIDTH,0);  
 
ObjectDelete("bm14_Line");
ObjectCreate("bm14_Line", OBJ_HLINE,0, Time[0],bm14);
ObjectSet("bm14_Line",OBJPROP_COLOR,DarkSlateGray);
ObjectSet("bm14_Line",OBJPROP_STYLE,STYLE_DASH);
ObjectSet("bm14_Line",OBJPROP_RAY,false);
ObjectSet("bm14_Line",OBJPROP_WIDTH,0);

ObjectDelete("bm16_Line");
ObjectCreate("bm16_Line", OBJ_HLINE,0, Time[0],bm16);
ObjectSet("bm16_Line",OBJPROP_COLOR,DarkSlateGray);
ObjectSet("bm16_Line",OBJPROP_STYLE,STYLE_SOLID);
ObjectSet("bm16_Line",OBJPROP_RAY,false);
ObjectSet("bm16_Line",OBJPROP_WIDTH,0); 

ObjectDelete("bm22_Line");
ObjectCreate("bm22_Line", OBJ_HLINE,0, Time[0],bm22);
ObjectSet("bm22_Line",OBJPROP_COLOR,DarkSlateGray);
ObjectSet("bm22_Line",OBJPROP_STYLE,STYLE_SOLID);
ObjectSet("bm22_Line",OBJPROP_RAY,false);
ObjectSet("bm22_Line",OBJPROP_WIDTH,0);  
 
ObjectDelete("bm24_Line");
ObjectCreate("bm24_Line", OBJ_HLINE,0, Time[0],bm24);
ObjectSet("bm24_Line",OBJPROP_COLOR,DarkSlateGray);
ObjectSet("bm24_Line",OBJPROP_STYLE,STYLE_DASH);
ObjectSet("bm24_Line",OBJPROP_RAY,false);
ObjectSet("bm24_Line",OBJPROP_WIDTH,0);

ObjectDelete("bm26_Line");
ObjectCreate("bm26_Line", OBJ_HLINE,0, Time[0],bm26);
ObjectSet("bm26_Line",OBJPROP_COLOR,DarkSlateGray);
ObjectSet("bm26_Line",OBJPROP_STYLE,STYLE_SOLID);
ObjectSet("bm26_Line",OBJPROP_RAY,false);
ObjectSet("bm26_Line",OBJPROP_WIDTH,0);  

ObjectDelete("bm32_Line");
ObjectCreate("bm32_Line", OBJ_HLINE,0, Time[0],bm32);
ObjectSet("bm32_Line",OBJPROP_COLOR,DarkSlateGray);
ObjectSet("bm32_Line",OBJPROP_STYLE,STYLE_SOLID);
ObjectSet("bm32_Line",OBJPROP_RAY,false);
ObjectSet("bm32_Line",OBJPROP_WIDTH,0);  
 
ObjectDelete("bm34_Line");
ObjectCreate("bm34_Line", OBJ_HLINE,0, Time[0],bm34);
ObjectSet("bm34_Line",OBJPROP_COLOR,DarkSlateGray);
ObjectSet("bm34_Line",OBJPROP_STYLE,STYLE_DASH);
ObjectSet("bm34_Line",OBJPROP_RAY,false);
ObjectSet("bm34_Line",OBJPROP_WIDTH,0);

ObjectDelete("bm36_Line");
ObjectCreate("bm36_Line", OBJ_HLINE,0, Time[0],bm36);
ObjectSet("bm36_Line",OBJPROP_COLOR,DarkSlateGray);
ObjectSet("bm36_Line",OBJPROP_STYLE,STYLE_SOLID);
ObjectSet("bm36_Line",OBJPROP_RAY,false);
ObjectSet("bm36_Line",OBJPROP_WIDTH,0);  

ObjectDelete("bm42_Line");
ObjectCreate("bm42_Line", OBJ_HLINE,0, Time[0],bm42);
ObjectSet("bm42_Line",OBJPROP_COLOR,DarkSlateGray);
ObjectSet("bm42_Line",OBJPROP_STYLE,STYLE_SOLID);
ObjectSet("bm42_Line",OBJPROP_RAY,false);
ObjectSet("bm42_Line",OBJPROP_WIDTH,0);  
 
ObjectDelete("bm44_Line");
ObjectCreate("bm44_Line", OBJ_HLINE,0, Time[0],bm44);
ObjectSet("bm44_Line",OBJPROP_COLOR,DarkSlateGray);
ObjectSet("bm44_Line",OBJPROP_STYLE,STYLE_DASH);
ObjectSet("bm44_Line",OBJPROP_RAY,false);
ObjectSet("bm44_Line",OBJPROP_WIDTH,0);

ObjectDelete("bm46_Line");
ObjectCreate("bm46_Line", OBJ_HLINE,0, Time[0],bm46);
ObjectSet("bm46_Line",OBJPROP_COLOR,DarkSlateGray);
ObjectSet("bm46_Line",OBJPROP_STYLE,STYLE_SOLID);
ObjectSet("bm46_Line",OBJPROP_RAY,false);
ObjectSet("bm46_Line",OBJPROP_WIDTH,0);  

ObjectDelete("bm52_Line");
ObjectCreate("bm52_Line", OBJ_HLINE,0, Time[0],bm52);
ObjectSet("bm52_Line",OBJPROP_COLOR,DarkSlateGray);
ObjectSet("bm52_Line",OBJPROP_STYLE,STYLE_SOLID);
ObjectSet("bm52_Line",OBJPROP_RAY,false);
ObjectSet("bm52_Line",OBJPROP_WIDTH,0);  
 
ObjectDelete("bm54_Line");
ObjectCreate("bm54_Line", OBJ_HLINE,0, Time[0],bm54);
ObjectSet("bm54_Line",OBJPROP_COLOR,DarkSlateGray);
ObjectSet("bm54_Line",OBJPROP_STYLE,STYLE_DASH);
ObjectSet("bm54_Line",OBJPROP_RAY,false);
ObjectSet("bm54_Line",OBJPROP_WIDTH,0);

ObjectDelete("bm56_Line");
ObjectCreate("bm56_Line", OBJ_HLINE,0, Time[0],bm56);
ObjectSet("bm56_Line",OBJPROP_COLOR,DarkSlateGray);
ObjectSet("bm56_Line",OBJPROP_STYLE,STYLE_SOLID);
ObjectSet("bm56_Line",OBJPROP_RAY,false);
ObjectSet("bm56_Line",OBJPROP_WIDTH,0);  

ObjectDelete("bm62_Line");
ObjectCreate("bm62_Line", OBJ_HLINE,0, Time[0],bm62);
ObjectSet("bm62_Line",OBJPROP_COLOR,DarkSlateGray);
ObjectSet("bm62_Line",OBJPROP_STYLE,STYLE_SOLID);
ObjectSet("bm62_Line",OBJPROP_RAY,false);
ObjectSet("bm62_Line",OBJPROP_WIDTH,0);  
 
ObjectDelete("bm64_Line");
ObjectCreate("bm64_Line", OBJ_HLINE,0, Time[0],bm64);
ObjectSet("bm64_Line",OBJPROP_COLOR,DarkSlateGray);
ObjectSet("bm64_Line",OBJPROP_STYLE,STYLE_DASH);
ObjectSet("bm64_Line",OBJPROP_RAY,false);
ObjectSet("bm64_Line",OBJPROP_WIDTH,0);

ObjectDelete("bm66_Line");
ObjectCreate("bm66_Line", OBJ_HLINE,0, Time[0],bm66);
ObjectSet("bm66_Line",OBJPROP_COLOR,DarkSlateGray);
ObjectSet("bm66_Line",OBJPROP_STYLE,STYLE_SOLID);
ObjectSet("bm66_Line",OBJPROP_RAY,false);
ObjectSet("bm66_Line",OBJPROP_WIDTH,0);

ObjectDelete("bm72_Line");
ObjectCreate("bm72_Line", OBJ_HLINE,0, Time[0],bm72);
ObjectSet("bm72_Line",OBJPROP_COLOR,DarkSlateGray);
ObjectSet("bm72_Line",OBJPROP_STYLE,STYLE_SOLID);
ObjectSet("bm72_Line",OBJPROP_RAY,false);
ObjectSet("bm72_Line",OBJPROP_WIDTH,0);  
 
ObjectDelete("bm74_Line");
ObjectCreate("bm74_Line", OBJ_HLINE,0, Time[0],bm74);
ObjectSet("bm74_Line",OBJPROP_COLOR,DarkSlateGray);
ObjectSet("bm74_Line",OBJPROP_STYLE,STYLE_DASH);
ObjectSet("bm74_Line",OBJPROP_RAY,false);
ObjectSet("bm74_Line",OBJPROP_WIDTH,0);

ObjectDelete("bm76_Line");
ObjectCreate("bm76_Line", OBJ_HLINE,0, Time[0],bm76);
ObjectSet("bm76_Line",OBJPROP_COLOR,DarkSlateGray);
ObjectSet("bm76_Line",OBJPROP_STYLE,STYLE_SOLID);
ObjectSet("bm76_Line",OBJPROP_RAY,false);
ObjectSet("bm76_Line",OBJPROP_WIDTH,0);

ObjectDelete("bm82_Line");
ObjectCreate("bm82_Line", OBJ_HLINE,0, Time[0],bm82);
ObjectSet("bm82_Line",OBJPROP_COLOR,DarkSlateGray);
ObjectSet("bm82_Line",OBJPROP_STYLE,STYLE_SOLID);
ObjectSet("bm82_Line",OBJPROP_RAY,false);
ObjectSet("bm82_Line",OBJPROP_WIDTH,0);  
 
ObjectDelete("bm84_Line");
ObjectCreate("bm84_Line", OBJ_HLINE,0, Time[0],bm84);
ObjectSet("bm84_Line",OBJPROP_COLOR,DarkSlateGray);
ObjectSet("bm84_Line",OBJPROP_STYLE,STYLE_DASH);
ObjectSet("bm84_Line",OBJPROP_RAY,false);
ObjectSet("bm84_Line",OBJPROP_WIDTH,0);

ObjectDelete("bm86_Line");
ObjectCreate("bm86_Line", OBJ_HLINE,0, Time[0],bm86);
ObjectSet("bm86_Line",OBJPROP_COLOR,DarkSlateGray);
ObjectSet("bm86_Line",OBJPROP_STYLE,STYLE_SOLID);
ObjectSet("bm86_Line",OBJPROP_RAY,false);
ObjectSet("bm86_Line",OBJPROP_WIDTH,0);
 
ObjectDelete("bm92_Line");
ObjectCreate("bm92_Line", OBJ_HLINE,0, Time[0],bm92);
ObjectSet("bm92_Line",OBJPROP_COLOR,DarkSlateGray);
ObjectSet("bm92_Line",OBJPROP_STYLE,STYLE_SOLID);
ObjectSet("bm92_Line",OBJPROP_RAY,false);
ObjectSet("bm92_Line",OBJPROP_WIDTH,0);  
 
ObjectDelete("bm94_Line");
ObjectCreate("bm94_Line", OBJ_HLINE,0, Time[0],bm94);
ObjectSet("bm94_Line",OBJPROP_COLOR,DarkSlateGray);
ObjectSet("bm94_Line",OBJPROP_STYLE,STYLE_DASH);
ObjectSet("bm94_Line",OBJPROP_RAY,false);
ObjectSet("bm94_Line",OBJPROP_WIDTH,0);

ObjectDelete("bm96_Line");
ObjectCreate("bm96_Line", OBJ_HLINE,0, Time[0],bm96);
ObjectSet("bm96_Line",OBJPROP_COLOR,DarkSlateGray);
ObjectSet("bm96_Line",OBJPROP_STYLE,STYLE_SOLID);
ObjectSet("bm96_Line",OBJPROP_RAY,false);
ObjectSet("bm96_Line",OBJPROP_WIDTH,0);

}
 
   
   }
 
//---- End Of Program
  return(0);
  }
//+------------------------------------------------------------------+